#import "MyOpenGLView.h"

typedef float vertex[3];

@implementation MyOpenGLView

- (void)prepareOpenGL
{
	
	NSLog(@"preparing openGL...");
	glClearColor(0.0f, 0.0f, 0.0f, 1.0f );
	
	glEnable(GL_DEPTH_TEST);
	glShadeModel(GL_SMOOTH);
	
	

	
	yRot = 45.0;
	xRot = 45.0;
}

- (void)reshape
{
	[[self openGLContext]makeCurrentContext];
	NSRect bounds = [self bounds];
	//NSLog(@"reshaping: %f, %f", NSWidth(bounds), NSHeight(bounds));
	glViewport(0, 0, NSWidth(bounds), NSHeight(bounds));
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glOrtho(-100, 100, -100, 100, -100, 100);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	[NSOpenGLContext clearCurrentContext];
}


- (void)drawRect:(NSRect)rect {
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	
	glLoadIdentity();
	glRotatef(xRot, 1.0f, 0.0f, 0.0f);
	glRotatef(yRot, 0.0f, 1.0f, 0.0f);
	
	
	OBJFileInfo objFile;
	firstPass(FILENAME4, objFile);
	OBJModel model(objFile);
	secondPass(FILENAME4, &model);
	
	
	
	for (int i=1; i<model.numVertices(); i++) {
		model.drawFaceAtIndex(i);
	}
	
	[[self openGLContext]flushBuffer];
}

- (IBAction)rotateUp:(id)sender
{
	xRot-= 5.0f;
	if(xRot < 1.0f)
		xRot = 355.0f;
	[self setNeedsDisplay:YES];
}
- (IBAction)rotateDown:(id)sender
{
	xRot += 5.0f;
	if(xRot > 356.0f)
		yRot = 0.0f;
	[self setNeedsDisplay:YES];
}
- (IBAction)rotateLeft:(id)sender
{
	yRot -= 5.0f;
	if(yRot < 1.0f)
		yRot = 355.0f;
	[self setNeedsDisplay:YES];
}
- (IBAction)rotateRight:(id)sender
{
	yRot += 5.0f;
	if(yRot > 356.0f)
		yRot = 0.0f;
	[self setNeedsDisplay:YES];
}
@end
